senp-validate
=============

jQuery form validation

how to:
* install
* setup
  * options
* extend
  * new regexp
  * launching plugin ( alpha stage )

##install
Add in the head of your page this tag
```
for debugging
<script type="text/javascript" src="senp-validate.js"></script>

or for production
<script type="text/javascript" src="senp-validate-min.js"></script>
```
##setup

You can setup it in two ways. 
1. giving a css selector to jQuery
2. calling directly the plugin

###1. Through a css selector

#####example:

`$('#my_button').senpValidate(options);`

###2. Calling directly the plugin

#####example:

`$.senpValidate(options);`

##options

You can specify this options for the plugin:
1. items
2. events
3. click

#####1. items:

it's an array of plain objects. Each object must have:
* selector
* errorMessage [optional]
* treshold, it's a number. After the string in the input/textarea reaches the length represented by treshold, the validation will begins. (default: 0)
* validate, it could be a regexp name or a function

regexp names:
* only digits - will validate only if you type only digits
* only numbers - will validate only if you type only numbers
* comma decimals - will validate only if you type a comma separated decimal number ( e.g. 10,02 )
* dotted decimals - will validate only if you type a dot separated decimal number ( e.g. 10.02 )
* email - validates an email

#####example:

```
$.senpValidate({
  items: [{
    errorMessage: 'This input accepts only digits',
    selector: '#input',
    validate: 'only digits',
    treshold: 3
  },{
    errorMessage: 'This input accepts only numbers',
    selector: '#input2',
    validate: function( string ) {
      // checks if there is no white space
      return string.replace(/\s+/g, '').length;
    }
  }]
})
```

#####2. events:

It's a string. The default is "keyup keydown". This is the basic event wich will fire the type in validation.

######example:

```
$.senpValidate({
  events: 'change click',
  items: [...items]
})
```

#####3. click:

It's a function. It require that a selector is passed when setupping the plugin.
It will provide as a formal parameter an array of not valid elements

#####example:

```
$('#my_button').senpValidate({
  click: function ( notValids ){
    // this array contains the non valid elements
  },
  items: [{
    errorMessage: 'This input accepts only digits',
    selector: '#input',
    validate: 'only digits'
  },{
    errorMessage: 'This input accepts only numbers',
    selector: '#input2',
    validate: 'only numbers'
  }]
})
```

## extending SenpValidate

At this moment you can actually extend SenpValidate only by setting up new regexps.

1. Setup a new regexp

####1. Setup a new regexp

It's really simple. There are two ways:

`$.senpValidate('newRegexp', 'regexpName', /[thisismyregex]/)`

or

```
$.senpValidate('newRegexp', {
  regexpName1: /[thisismyregex1]/
  regexpName2: /[thisismyregex2]/
});
```