  // exposing as a jQuery plugin
  $.senpValidate = $.senp_validate = $.fn.senpValidate = $.fn.senp_validate = function ( configObject ) {
    
    // setting up the main module instance
    var api = Api(),
      initInstance = Init(configObject),
      validateInstance = new Validate,
      tooltip = Tooltip();
    
    // calling the api plugins
    api.callPlugins({
      core: initInstance,
      validate: Validate,
      tooltip: tooltip
    });
    
    // if there are more than one arguments...it will fire the api dispatcher instead
    // of doing the normal jobs.   
    if( [].slice.call(arguments).length > 1 ) {
      // routing to apis module
      api = Api( configObject, [].slice.call(arguments,1));
      return this;
    }
    
    // binding each item
    initInstance.bind( function(){
      
      var self = $(this),
        data = self.data('senpValidate'),
        errorMessage = data.errorMessage,
        isValid = Validate(this.value, data.validate);
      
      if (this.value.length < data.treshold) {
        return;
      }
      
      if( !isValid ) {
        if( errorMessage ) {
          tooltip.getElementPosition(this);
          tooltip.tooltip.show().css( tooltip.guessTooltipPosition() );
          tooltip.setMessage( errorMessage.title || '', errorMessage.text || errorMessage );
        }
        self.addClass('not-valid');
      } else {
        tooltip.tooltip.hide();
        self.removeClass('not-valid');
      }
    });
    
    // if there is a selector, it will be bound to mass validate the items
    if( this.selector ){
      this.unbind('click').bind('click', function(){
        
        var _clickValid = ValidateAll(initInstance, Validate),
          notValidElements = _clickValid.notValid;
        
        _clickValid.callback.call(this, {
          valid: !notValidElements.length,
          notValid: notValidElements
        });
        
        tooltip.getElementPosition(this);
      });
    }
    return this;
  }
  // that's all folks :3