// builder module
var Init = (function ($) {

  // each helper function. It's an iterator.
  function _each (array, callback) {
    var k = 0;
    while (k < array.length) {
      callback.call(this, array[k], k);
      k++;
    }
    return array;
  };

  // will be the data instance id
  var date = new Date,
  // constructor function
  init = function (object) {
    this.instanceId = date.toLocaleString().replace(/\D+/g, '');
    this.events = object.events || 'keyup keydown';
    this.items = object.items || [];
    this.object = object;
    return this;
  },
  // binding for every single element
  bind = function (callback) {
    return this.each (function(item) {
      $(item.selector).unbind(this.events).bind(this.events, function() {
        callback.call(this);
      });
    });
  },
  // a simple iterator
  each = function (callback) {
    _each.call(this, this.items, callback);
    return this;
  },
  // preparing the items ( passing jquery datas )
  prepare = function() {
    return this.each(function(item) {
      item.id = this.instanceId;
      item.treshold = item.treshold || 0; 
      $(item.selector).data('senpValidate', item);
    });
  }
  // prototyping Init
  init.prototype = {
    bind : bind,
    each : each,
    prepare : prepare
  }
  // returns as a function
  return function (object) {
    var _init = new init(object || {});
    return _init.prepare();
  }
})($); 