  var Validate = ( function (regexpLibrary) {
    // validation
    var validate = function(string, expected){
      this.string = string;
      if( typeof expected == 'function' ){
        this.expected = expected || function(){};
      }else{
        this.expected = this.regexp[expected.toLowerCase().replace(/\s+/g, '')] || false;
      }
      return this;
    },
    // responsible for checking if a string is valid or not
    check = function(){
      if(!this.expected){
        return false;
      }
        
      if (typeof this.expected == 'function'){
        return this.expected.call(this, this.string);  
      }
      return this.expected.test(this.string);
    };
    // prototyping validate
    validate.prototype = {
      check: check,
      regexp: regexpLibrary
    }
    // returning the function as a module
    return function(string, expectedResult){
      return new validate(string, expectedResult || '').check();
    }
  })(regexpLibrary);